/*
 		     
 				  G77E0
 				(PCF8535)
				24.02.2013
									*/

#include "graphics.h"
#include "letters.h"

/////////////////////////////////////////////////////////////////////
//////////////////////   /////////////////////
/////////////////////////////////////////////////////////////////////
void init_Screen(void)
	{
	RES_INDIC_PORT|=_BV(RES_INDIC);		//  RES_INDIC "1"
	RES_INDIC_DDR |=_BV(RES_INDIC);		//  RES_INDIC  
	for(int i=0; i<1000; i++);

	StartI2C();							//
	WriteI2C_ADDR(addr_screen, write);	//     
	WriteI2C(0b00000000);				// control byte, Co=0, D/C=0
	WriteI2C(0x01);						//    H[1:0]=111
		WriteI2C(0b00010000);			// PD=0( ); V=0( )
	WriteI2C(0b00001110);				//   H[1:0]=110
		WriteI2C(0b00010001);			// BIAS = 1/10	-	   5
		//WriteI2C(0b00010100); 			// BIAS = 1/7	-	   USB
		WriteI2C(0b00000110);			// display mode D=1, E=0 - normal mode
		WriteI2C(0b10000100);			// MUX = 1/65
		WriteI2C(0b00001000);			//  (MX=0, MY=0)
		WriteI2C(0b00100100);			//   IB = 1
	WriteI2C(0x01);						//    H[1:0]=111
	WriteI2C(0b00001101);				//   H[1:0]=101		
		WriteI2C(0b00001000);			// S[1:0] = 00, mul factor = 2 (2*Vdd2)
		WriteI2C(0b00010010);			//   2
		WriteI2C(0b10101000);			// 
		WriteI2C(0b00000111);			// 
	StopI2C();

	Clear_RAM_LCD();
	Clear_LCD();
	}

/////////////////////////////////////////////////////////////////////
///////////////////////   ///////////////////////////
/////////////////////////////////////////////////////////////////////
void LCD_Set_Pos (char x, char y)//x=0..127,y=0..7
	{
	StartI2C();
	WriteI2C_ADDR(addr_screen, write);	//     
	WriteI2C(0);						//control byte C0=0,D/C=0;
	WriteI2C(0b00000001);				//LCD_COMMAND_DEF_PAGE
	WriteI2C(0b00100000);				//set ram page 0
	WriteI2C(0b01000000|y);				//set y pos
	WriteI2C(0b10000000|x);				//set x pos
	StopI2C();
	}

/////////////////////////////////////////////////////////////////////
///////////////////////   /////////////////////////
/////////////////////////////////////////////////////////////////////
void Clear_LCD(void)
	{
	LCD_Set_Pos (0,0);
	StartI2C();
	WriteI2C_ADDR(addr_screen, write);	//     
	WriteI2C(0b01000000);				// control byte
	for(int byte_number=0;byte_number<1060;byte_number++)
	WriteI2C(0x0);
	StopI2C();
	}

/////////////////////////////////////////////////////////////////////
///////////////////////   /////////////////////////
/////////////////////////////////////////////////////////////////////
void Clear_RAM_LCD(void)
	{
	int i;
	for(i=0;i<512;i++)
	RAM_LCD[i]=0;
	}

/////////////////////////////////////////////////////////////////////
/////////////////    ////////////////
/////////////////////////////////////////////////////////////////////
char area_RAM_LCD(char Xn, char Yn, char width, char height, char mode)
	{
	int		bit_RAM_lcd, t3;
	char	bank_vivoda, Shift, t1, t4;

	t3=((Yn/8)*128)+Xn;			//         
	Shift = (Yn%8);				// ,     
	t4=8-Shift;					//        

	if((Shift+height)<8)			//            
		{
		t1=0;
		for(int i=0; i<(Shift+height); ++i)	//        RAM_LCD
			{
			t1>>=1;
			if(i<height) {t1|=0b10000000;};
			};
		t1^=0xFF;	
		for (bit_RAM_lcd=t3; bit_RAM_lcd<t3+width; bit_RAM_lcd++)
			{
			if(mode == white)
				{
				RAM_LCD[bit_RAM_lcd] = RAM_LCD[bit_RAM_lcd]&t1;
				}			
			if(mode == black)
				{
				RAM_LCD[bit_RAM_lcd] = RAM_LCD[bit_RAM_lcd]|(~t1);
				}
			};
		}
	else						//             3  		
		{
		
		// 0-  
		for (bit_RAM_lcd=t3; bit_RAM_lcd<t3+width; bit_RAM_lcd++)
			{			
			if(mode == white)
				{
				RAM_LCD[bit_RAM_lcd] = RAM_LCD[bit_RAM_lcd]&(0xFF<<t4);
				bank_vivoda=1;
				}
			if(mode == black)
				{
				RAM_LCD[bit_RAM_lcd] = RAM_LCD[bit_RAM_lcd]|(0xFF>>Shift);
				bank_vivoda=1;
				}		
			};
		//  
		for(int i=(height-t4);i>8; i=i-8)
			{
			for (bit_RAM_lcd=t3+(128*bank_vivoda); bit_RAM_lcd<t3+(128*bank_vivoda)+width; bit_RAM_lcd++)	
				{
				if(mode == white)
					{
					RAM_LCD[bit_RAM_lcd]=0x00;
					}
				if(mode == black)
					{
					RAM_LCD[bit_RAM_lcd]=0xFF;
					}	
				};
			bank_vivoda++;
			};
		//  
		for (bit_RAM_lcd=t3+(128*bank_vivoda); bit_RAM_lcd<t3+(128*bank_vivoda)+width; bit_RAM_lcd++)	
			{
			if(mode == white)
				{	
				RAM_LCD[bit_RAM_lcd]=RAM_LCD[bit_RAM_lcd]&(0xFF>>(height-(t4+((bank_vivoda-1)*8))));
				}
			if(mode == black)
				{
				t1=~(0xFF>>(height-(t4+((bank_vivoda-1)*8))));	
				RAM_LCD[bit_RAM_lcd]=RAM_LCD[bit_RAM_lcd]|t1;
				}		
			};
		}
	return width;
	}


/////////////////////////////////////////////////////////////////////
//////      ( ) //////
/////////////////////////////////////////////////////////////////////
void refresh_screen(char row, char col, char height, char width)	// row  height -   (8 )
	{
	char a, b;
	for( a=0; a<height; a++)
		{
		LCD_Set_Pos (col, row+a);
		StartI2C();
		WriteI2C_ADDR(addr_screen, write);	//     
		WriteI2C(0b01000000);				// control byte, Co=0, D/C=1		//StartI2C();
		for( b=0; b<width; b++)
			WriteI2C(RAM_LCD[((row+a)*128)+b]);
		StopI2C();
		}

	}

/////////////////////////////////////////////////////////////////////
/////////////       /////////////
/////////////////////////////////////////////////////////////////////
void refresh_all_screen(void)
	{
	LCD_Set_Pos (0,0);
	StartI2C();
	WriteI2C_ADDR(addr_screen, write);	//     
	WriteI2C(0b01000000);				// control byte, Co=0, D/C=1
	for(int a=0 ;a<8; a++)
		{
		for(int b=0 ;b<133; b++)
			{
			WriteI2C(RAM_LCD[(b+(128*a))]);
			}
		}
	StopI2C();
	}

/////////////////////////////////////////////////////////////////////
////////////////    ""  ////////////////
/////////////////////////////////////////////////////////////////////
void fill_picture_area(char *pic)
{
for(int i=0;i<512;i++) RAM_LCD[i]=pgm_read_byte(&(pic[i+2]));
}

/////////////////////////////////////////////////////////////////////
//////////////////     /////////////////
/////////////////////////////////////////////////////////////////////
char insert_pic(char Xn, char Yn, char *pic)
	{
	int		bit_RAM_lcd, t3;
	char	bank_vivoda, Shift, Xr, Yr, t1, t2, t4;

	Xr = pgm_read_byte(&(pic[0]));
	Yr = pgm_read_byte(&(pic[1]));
	t3=((Yn/8)*128)+Xn;			//         
	Shift = (Yn%8);				// ,     
	t4=8-Shift;					//        

	if((Shift+Yr)<8)			//            
		{
		t1=0;
		for(int i=0; i<(Shift+Yr); ++i)	//        RAM_LCD
			{
			t1>>=1;
			if(i<Yr) {t1|=0b10000000;};
			};
		t1^=0xFF;	
		for (bit_RAM_lcd=t3; bit_RAM_lcd<t3+Xr; bit_RAM_lcd++)
			{
			t4= RAM_LCD[bit_RAM_lcd]&t1;
			t2 = pgm_read_byte(&(pic[(bit_RAM_lcd+2)-t3])) >> Shift;
			RAM_LCD[bit_RAM_lcd] = t4|t2;
			};
		}
	else						//             3  		
		{
		
		// 0-     
		for (bit_RAM_lcd=t3; bit_RAM_lcd<t3+Xr; bit_RAM_lcd++)
			{
			t1= RAM_LCD[bit_RAM_lcd]&(0xFF<<t4);
			t2 = pgm_read_byte(&(pic[(bit_RAM_lcd+2)-t3])) >> Shift;
			RAM_LCD[bit_RAM_lcd] = t1|t2;
			bank_vivoda=1;
			};
		//      
		for(int i=(Yr-t4);i>8; i=i-8)
			{
			for (bit_RAM_lcd=t3+(128*bank_vivoda); bit_RAM_lcd<t3+(128*bank_vivoda)+Xr; bit_RAM_lcd++)	
				{
				t1 = pgm_read_byte(&(pic[(((bit_RAM_lcd+2)-(t3+(128*bank_vivoda)))+(Xr*(bank_vivoda-1)))]));
				t1 <<= t4;
				t2 = pgm_read_byte(&(pic[(((bit_RAM_lcd+2)-(t3+(128*bank_vivoda)))+(Xr*(bank_vivoda)))]));
				t2 >>= Shift;
				RAM_LCD[bit_RAM_lcd]=t1|t2;
				};
			bank_vivoda++;
			};
		//      
		for (bit_RAM_lcd=t3+(128*bank_vivoda); bit_RAM_lcd<t3+(128*bank_vivoda)+Xr; bit_RAM_lcd++)	
			{
			t1 = pgm_read_byte(&(pic[(((bit_RAM_lcd+2)-(t3+(128*bank_vivoda)))+(Xr*(bank_vivoda-1)))]));
			t1 <<= t4;
			t2 = pgm_read_byte(&(pic[(((bit_RAM_lcd+2)-(t3+(128*bank_vivoda)))+(Xr*(bank_vivoda)))]));
			t2 >>= Shift; 
			t1=(t1|t2) & (0xFF<<(8-(Yr-(t4+((bank_vivoda-1)*8)))));
			t2 = RAM_LCD[bit_RAM_lcd]&(0xFF>>(Yr-(t4+((bank_vivoda-1)*8))));	
			RAM_LCD[bit_RAM_lcd]=t1|t2;
			};
		}
	return t3=Xr;
	}

/////////////////////////////////////////////////////////////////////
////////////       ///////////////
/////////////////////////////////////////////////////////////////////
char put_bstring(char col, char line_start, char *str)
	{
	char p_col, row_start, height, width;
	char *ptr;	
	ptr = str;
	p_col = col;
	row_start = line_start/8;
	height = 2;
	if( (line_start % 8) > 0 )
	height = 3;
	while(*ptr != 0 )
		{
		p_col += insert_pic( p_col, line_start, get_bpointer(*ptr));
		ptr++;
		}
	width = p_col - col;
	//refresh_screen( row_start, col, height, width);
	return width;
	}

/////////////////////////////////////////////////////////////////////
////////////        /////////////
/////////////////////////////////////////////////////////////////////
void put_bsfigure(char Xn, char Yn, int X)
	{
	int t1, t2;                                  
	t1=Xn;
	t2=0;
	if ((X/1000!=0) || (t2!=0)) {t1+=insert_pic(t1, Yn, get_bpointer(X/1000)); t2=1;}; 
	X=X%1000;
	if ((X/100!=0) || (t2!=0))  {t1+=insert_pic(t1, Yn, get_bpointer(X/100)); t2=1;};
	X=X%100;
	if ((X/10!=0) || (t2!=0))   {t1+=insert_pic(t1, Yn, get_bpointer(X/10)); t2=1;};
	X=X%10;
									 t1+=insert_pic(t1, Yn, get_bpointer(X)); 
	}
	

/////////////////////////////////////////////////////////////////////
//////////////////////   /////////////////////////
/////////////////////////////////////////////////////////////////////
void draw_hline(char x, char y, char x_end ) 
{
}

/////////////////////////////////////////////////////////////////////
///////////////////////   //////////////////////////
/////////////////////////////////////////////////////////////////////
void draw_vline(char x, char y, char y_end ) 
{
}

/////////////////////////////////////////////////////////////////////
///////////////////     -  /////////////////////
/////////////////////////////////////////////////////////////////////
void Draw_Clock(void)
{
}

/////////////////////////////////////////////////////////////////////
//////////////// /////   /////////////////////////
/////////////////////////////////////////////////////////////////////
void Draw_Main_Screen(void)
{
Clear_LCD();
}


//---------------------------------------------------------------------------------------------











