#include "globals.h"
#include "graphics.h"
#include "menu.h"
#include "keyboard.h"
#include "messages.h"
#include "lcd.h"


typedef struct PROGMEM{
	void       *Next;
	void       *Previous;
	void       *Parent;
	void       *Child;
    FuncPtr     SelectFunc;
	FuncPtr     EnterFunc;
	const char  Text[10];
} menuItem;

menuItem* selectedMenuItem; //   

menuItem* menuStack[10];
volatile uint8_t menuStackTop;

menuItem* tempMenu;			//    
char mas[10];

  #define MAKE_MENU(Name, Next, Previous, Parent, Child, SelectFunc, EnterFunc, Text) \
    extern menuItem Next;     \
	extern menuItem Previous; \
	extern menuItem Parent;   \
	extern menuItem Child;  \
	  menuItem Name = {(void*)&Next, (void*)&Previous, (void*)&Parent, (void*)&Child, (FuncPtr)SelectFunc, (FuncPtr)EnterFunc, { Text }}

#define PREVIOUS   ((menuItem*)pgm_read_word(&selectedMenuItem->Previous))
#define NEXT       ((menuItem*)pgm_read_word(&selectedMenuItem->Next))
#define PARENT     ((menuItem*)pgm_read_word(&selectedMenuItem->Parent))
#define CHILD      ((menuItem*)pgm_read_word(&selectedMenuItem->Child))


char strNULL[] PROGMEM = "";

#define NULL_ENTRY Null_Menu
Menu_Item        Null_Menu = {(void*)0, (void*)0, (void*)0, (void*)0, (FuncPtr*)0, (FuncPtr*)0, {0x00}};



//-----------------------------------------------------------------------------------------
void OUT_L1_I1(void) {
char t;
t=42;
Clear_RAM_LCD();
put_bstring(19,	46, ", ");
put_bstring(13,	29,	", ");
put_bstring(5, 	12, " ");
area_RAM_LCD(3, 	t+9+7,	122, 	1, 		black);
area_RAM_LCD(3, 	t, 		122, 	1, 		black);
area_RAM_LCD(3, 	t, 		1, 		9+7, 	black);
area_RAM_LCD(124, 	t, 		1, 		9+7, 	black);
refresh_all_screen();
};

void OUT_L1_I2(void) {
char t;
t=25;
Clear_RAM_LCD();
put_bstring(19, 46, ", ");
put_bstring(13, 29, ", ");
put_bstring(5, 	12, " ");
area_RAM_LCD(3, 	t+9+7,	122, 	1, 		black);
area_RAM_LCD(3, 	t, 		122, 	1, 		black);
area_RAM_LCD(3, 	t, 		1, 		9+7, 	black);
area_RAM_LCD(124, 	t, 		1, 		9+7, 	black);
refresh_all_screen();
};

void OUT_L1_I3(void) {
char t;
t=8;
Clear_RAM_LCD();
put_bstring(19, 46, ", ");
put_bstring(13, 29, ", ");
put_bstring(5, 	12, " ");
area_RAM_LCD(3, 	t+9+7,	122, 	1, 		black);
area_RAM_LCD(3, 	t, 		122, 	1, 		black);
area_RAM_LCD(3, 	t, 		1, 		9+7, 	black);
area_RAM_LCD(124, 	t, 		1, 		9+7, 	black);
refresh_all_screen();
};
//-----------------------------------------------------------------------------------------
void OUT_L1_I1_S1(void) {
char t;
t=42;
Clear_RAM_LCD();
put_bstring(44, 46, "");
put_bstring(43, 29, "");
area_RAM_LCD(3, 	t+9+7,	122, 	1, 		black);
area_RAM_LCD(3, 	t, 		122, 	1, 		black);
area_RAM_LCD(3, 	t, 		1, 		9+7, 	black);
area_RAM_LCD(124, 	t, 		1, 		9+7, 	black);
refresh_all_screen();
};

void OUT_L1_I1_S2(void) {
char t;
t=25;
Clear_RAM_LCD();
put_bstring(44, 46, "");
put_bstring(43, 29, "");
area_RAM_LCD(3, 	t+9+7,	122, 	1, 		black);
area_RAM_LCD(3, 	t, 		122, 	1, 		black);
area_RAM_LCD(3, 	t, 		1, 		9+7, 	black);
area_RAM_LCD(124, 	t, 		1, 		9+7, 	black);
refresh_all_screen();
};
//-----------------------------------------------------------------------------------------
void OUT_L1_I2_S1(void) {
char t;
t=42;
Clear_RAM_LCD();
put_bstring(50, 46, "");
put_bstring(35, 29, "");
area_RAM_LCD(3, 	t+9+7,	122, 	1, 		black);
area_RAM_LCD(3, 	t, 		122, 	1, 		black);
area_RAM_LCD(3, 	t, 		1, 		9+7, 	black);
area_RAM_LCD(124, 	t, 		1, 		9+7, 	black);
refresh_all_screen();
};

void OUT_L1_I2_S2(void) {
char t;
t=25;
Clear_RAM_LCD();
put_bstring(50, 46, "");
put_bstring(35, 29, "");
area_RAM_LCD(3, 	t+9+7,	122, 	1, 		black);
area_RAM_LCD(3, 	t, 		122, 	1, 		black);
area_RAM_LCD(3, 	t, 		1, 		9+7, 	black);
area_RAM_LCD(124, 	t, 		1, 		9+7, 	black);
refresh_all_screen();
};
//-----------------------------------------------------------------------------------------

// Menus:				  		NEXT,	 	 PREVIOUS	   PARENT		CHILD
MAKE_MENU(Level1Item1, 	  Level1Item2, 	  Level1Item3,    NULL_ENTRY, Level1Item1Sub1, NULL_FUNC, OUT_L1_I1, 	", ");
MAKE_MENU(Level1Item2, 	  Level1Item3, 	  Level1Item1,    NULL_ENTRY, Level1Item2Sub1, NULL_FUNC, OUT_L1_I2, 	", ");
MAKE_MENU(Level1Item3,    Level1Item1, 	  Level1Item2, 	  NULL_ENTRY, NULL_ENTRY,	   NULL_FUNC, OUT_L1_I3, 	" ");

//  "  ":	NEXT,	 	 PREVIOUS	   PARENT		CHILD
MAKE_MENU(Level1Item1Sub1,Level1Item1Sub2,Level1Item1Sub2,Level1Item1,NULL_ENTRY, 	   NULL_FUNC, OUT_L1_I1_S1, "");
MAKE_MENU(Level1Item1Sub2,Level1Item1Sub1,Level1Item1Sub1,Level1Item1,NULL_ENTRY, 	   NULL_FUNC, OUT_L1_I1_S2, "");

//  ", ":	NEXT,	 	 PREVIOUS	   PARENT		CHILD
MAKE_MENU(Level1Item2Sub1,Level1Item2Sub2,Level1Item2Sub2,Level1Item2,NULL_ENTRY,     NULL_FUNC, OUT_L1_I2_S1, "");
MAKE_MENU(Level1Item2Sub2,Level1Item2Sub1,Level1Item2Sub1,Level1Item2,NULL_ENTRY,	   NULL_FUNC, OUT_L1_I2_S2, "");





void menuChange(menuItem* NewMenu)
{
	if ((void*)NewMenu == (void*)&NULL_ENTRY)
	  return;

	selectedMenuItem = NewMenu;
}

unsigned char dispMenu(msg_par par) {
	
	//menuItem* tempMenu;			//    
	//char mas[10];

	//   - .     
	/////////////////lcd_gotoxy(1,0);
	Clear_RAM_LCD();			//  
	tempMenu = (menuItem*)pgm_read_word(&selectedMenuItem->Parent);
	if ((void*)tempMenu == (void*)&NULL_ENTRY) { //    
		put_bstring(40, 40, "");
	} else {
		for(int i=0; i<10;i++) {		//        flash  ROM
		mas[i]= pgm_read_byte(&tempMenu->Text[i]);
		}
		put_bstring(40, 40, mas);
	}
	//   -   
    for(int i=0; i<10;i++) {			//        flash  ROM
		mas[i]= pgm_read_byte(&selectedMenuItem->Text[i]);
		}
	put_bstring(40, 20, mas);
	refresh_all_screen();				//   
	return (1);
}

uint8_t menuKey(msg_par par) {
	switch (par) {
	case 0: {
		return 1;
	}
	case KEY_LEFT: {
		menuChange(PARENT);
		break;
	}
	case KEY_RIGHT: {
		menuChange(CHILD);
		break;
	}
	case KEY_DOWN:
		{
		menuChange(NEXT);
		break;
	}
	case KEY_UP: { //   ()
		menuChange(PREVIOUS);
		break;
	}
	case KEY_OK:
		{ //  
			uint8_t sel;
			sel = 1;
			if (sel != 0) {
				sendMessage(MSG_MENU_SELECT, sel);

				//killHandler(MSG_KEY_PRESS, &menuKey);		//   - 
				//killHandler(MSG_DISP_REFRESH, &dispMenu);	//   - 

				return (1);
			} else {
				menuChange(CHILD);
			}
			break;
		}
	
	}
	dispMenu(0);
	return (1);
}

uint8_t startMenu() {
	selectedMenuItem = (menuItem*)&Level1Item1;

	dispMenu(0);
	setHandler(MSG_KEY_PRESS, &menuKey);
	//setHandler(MSG_DISP_REFRESH, &dispMenu);
	return (0);
}

void initMenu() {
	lcd_init();
}
